<?php

// 2017.01.03 bY Stefano.Deiuri@Elettra.Eu

define( 'ROOT_PATH', '' ); // ex. /web/httpd/htdocs/events/2016/cws2

$cws_config =array(
	'global' =>array(	
		'conf_name'			=>'', // ex. IPAC16
		'spms_url'			=>'', // ex. http://spms.kek.jp/pls/ipac16
		'spms_passphrase'	=>'', // no ex.
		'cws_timezone'		=>'', // ex. Asia/Seoul OR Europe/Rome
		
		'root_path'			=>ROOT_PATH,
		'data_path'			=>'{root_path}/data',
		'out_path'			=>'{root_path}/html',
		'tmp_path'			=>'{root_path}/tmp',
		
		'root_url'			=>'', //ex. http://www.elettra.eu/events/2016/cws2
		
		'cron_enabled'		=>false,
		
		'wget_options'		=>'-q',
		
		'debug'				=>false,
		'colored_output'	=>false,
		'verbose'			=>2,

		'chart_type'		=>'LineChart', // LineChart or AreaChart
		'chart_width'		=>800,
		'chart_height'		=>300,
		'chart_color1'		=>'#0066ff'
		),

	//-------------------------------------------------------------------------------------------------
	'spms_importer' =>array(
		'name'			=>'SPMS Importer',
		'cron'			=>'*:00',
		
		'wget'			=>true,
		'skip_sessions'	=>false,		

		'tmp_path'		=>'{tmp_path}/spms',
		
		// out
		'abstracts'		=>'{app_data_path}/abstracts.json',
		'programme'		=>'{app_data_path}/programme.json',
		'posters'		=>'{app_data_path}/posters.json',
		'po'			=>'{app_data_path}/po.json'
		),
	//-------------------------------------------------------------------------------------------------
	'spms_stats_importer' =>array(
		'name'			=>'SPMS Statistics Importer',
		'cron'			=>'*:*',
		
		'edot_xml_url'	=>'{spms_url}/edot.xml',

		// in
		'po'			=>'{data_path}/po.json',

		// out
		'edot_xml'		=>'{tmp_path}/edot.xml',
		'edot'			=>'{data_path}/edot.json',
		'stats'			=>'{data_path}/stats.json'
		),
		
	//-------------------------------------------------------------------------------------------------
	'make_chart_abstracts' =>array(
		'name'				=>'Chart Abstracts Submission',
		'cron'				=>'*:05',
		
		'xtract'			=>'abstractsubmissions',
		'y_title'			=>'Abstracts',
		'startdate'			=>false, // ex. Y-m-d '2017-1-1', m =(month -1) 1 = feb
		'showmaxvalue'		=>false,
		'skip_format_check'	=>false, // usefull for regstats
		
		// in
		'chart_js'			=>'chart.js',
		'chart_html'		=>'chart.html',

		// out
		'out_js'			=>'chart_abstracts.js',
		'out_html'			=>'chart_abstracts.html'
	),
		
	//-------------------------------------------------------------------------------------------------
	'make_chart_papers' =>array(
		'name'				=>'Chart Papers Submission',
		'cron'				=>'*:05',
		
		'xtract'			=>'filesuploaded,papercode',
		'y_title'			=>'Papers',
		'startdate'			=>false,
		'showmaxvalue'		=>false,
		'skip_format_check'	=>false, // usefull for regstats
		
		// in		
		'chart_js'			=>'chart.js',
		'chart_html'		=>'chart.html',
		
		// out
		'out_js'			=>'chart_papers.js',
		'out_html'			=>'chart_papers.html'
		),		
		
	//-------------------------------------------------------------------------------------------------
	'make_chart_registrants' =>array(
		'name'				=>'Chart Registrants',
		'cron'				=>'*:05',
		
		'xtract'			=>'regstats',
		'y_title'			=>'Registrants',
		'startdate'			=>false,
		'showmaxvalue'		=>false,
		'skip_format_check'	=>true, // usefull for regstats
		
		// in		
		'chart_js'			=>'chart.js',
		'chart_html'		=>'chart.html',

		// out
		'out_js'			=>'chart_registrants.js',
		'out_html'			=>'chart_registrants.html'
		),		
		
	//-------------------------------------------------------------------------------------------------
	'make_page_participants' =>array(
		'name'				=>'Page Registrants',
		'cron'				=>'*:05',
		
		// chart
		'xtract'			=>'regstats',
		'y_title'			=>'Registrants',
		'startdate'			=>false,
		'showmaxvalue'		=>false,
		'skip_format_check'	=>true, // usefull for regstats

		// list
		'xtract2'			=>'attendees',
		'chart_var'			=>'Registrants',
		
		// in		
		'chart_js'			=>'chart.js',
		'template_html'		=>'template.html',
		'css'				=>'Participants.css',
		
		// out
		'out_js'			=>'chart_participants.js',
		'out_css'			=>'participants.css',		
		'out_html'			=>'participants.html'
		),
		
	//-------------------------------------------------------------------------------------------------
	'make_page_programme' =>array( 
		'name'			=>'Programme',
		'cron'			=>'*:05',
		
		'img_path'		=>'programme/images',
		'base_url'		=>'programme.php',
		'tab_w'			=>" width='750'",
		
		'default_page'	=>'html/programme.php',
		
		'tsz_adjust'	=>0,
	
		// in
		'abstracts'		=>'{app_data_path}/abstracts.json',
		'programme'		=>'{app_data_path}/programme.json',

		// out
		'out_path'		=>'{out_path}/programme',
		'ics'			=>'{app_out_path}/programme.ics'
		),
		
	//-------------------------------------------------------------------------------------------------
	'app_paper_status' =>array(
		'name'			=>'Paper Status App',
		'cron'			=>'*:*',

		'echo_mode'		=>'web',

		'data_path'		=>'{data_path}/{app}',
		'tmp_path'		=>'{tmp_path}/{app}',

//		'edot_xml_url'	=>'{spms_url}/edot.xml',

		'default_page'	=>'{app}/index.php',
		
		// in
		'template_html'	=>'template.html',
		'po'			=>'{data_path}/po.json',
		'edot'			=>'{data_path}/edot.json',

		// out
//		'edot_xml'		=>'{app_tmp_path}/edot.xml',
//		'stats'			=>'{app_data_path}/stats.json',
		'log'			=>'{app_data_path}/usage.log'
		),
		
	//-------------------------------------------------------------------------------------------------
	'app_poster_police' =>array(
		'name'			=>'Poster Police App',
		'dummy_mode'	=>true,
		'pp_manager'	=>00000, // PosterPolice PersonID
		'password'		=>'0101',

		'verbose'		=>0,
		'echo_mode'		=>'web',
		
		'data_path'		=>'{data_path}/{app}',

		'default_page'	=>'{app}/index.php',
		
		// in
		'pp'			=>'{data_path}/posters.json',
		
		// out
		'sync_url'		=>'{spms_url}/xtract.posterpolicesetstatus'
		),
		
	//-------------------------------------------------------------------------------------------------
	'page_po_status' =>array(
		'name'			=>'Proceeding Office Status Page',

		'echo_mode'		=>'web',
		
		'default_page'	=>'{app}/index.php',

		// in
		'template_html'	=>'template.html',
		'edot'			=>'{data_path}/edot.json',
		'stats'			=>'{data_path}/stats.json',
		'po'			=>'{data_path}/po.json'
		),
		
	//-------------------------------------------------------------------------------------------------
	'barcode' =>array(
		'name'			=>'BarCode Page',
		
		'echo_mode'		=>'web',
		
		'apk'			=>'JACoW_BarCode.apk',
		
		'data_path'		=>'{data_path}/{app}',
		'data_url'		=>'{root_url}/data/{app}', 

		'default_page'	=>'{app}/index.php',

		// in
		'template_html'	=>'template.html',
		'po'			=>'{data_path}/po.json',
		
		// out
		'log'			=>'{app_data_path}/usage.log'		
		)		
	);

	
//----------------------------------------------------------------------------
function require_lib( $_name, $_version ) {
 $fname =ROOT_PATH .'/libs/' .$_name .'-' .$_version .'.lib.php';
 
 if (!file_exists($fname)) {
	echo "\n\nERROR: unable to load lib $_name-$_version\n\nPlease check the ROOT_PATH!\n\n";
 }
 
 require_once( $fname );
}
	
?>