<?php

// 2017.01.03 bY Stefano.Deiuri@Elettra.Eu

error_reporting(E_ERROR);

require( '../config.php' );
require_lib( 'cws', '1.0' );

config( 'page_po_status' );


$stats_title =array(
	'files' 	=>'Ready for processing',
	'a' 		=>'Assigned to an Editor',
	'g' 		=>'GREEN DOT (successfully processed)',
	'y' 		=>'YELLOW DOT (wait author approval)',
	'r' 		=>'RED DOT (unsuccessfully processed)',
	'nofiles' 	=>'No valid files uploaded yet'
	);
	

if (!need_file( APP_EDOT ) || !need_file( APP_STATS )) {
	echo_error( "\n\nTry to run spms_stats_importer/make.php!" );
	die;
}	
	
	
$dots =file_read_json( APP_EDOT, true );

$stats_db =file_read_json( APP_STATS, true );

$stats =end($stats_db);

/*-----------------------------------------------------------------------------
  EDOTS
*/

$ndot =0;
foreach ($dots as $paper_id =>$p) {
	if ($p['pc'] == 'Y') $ndot ++;
}

$dot_size =floor( 1200 /sqrt( $ndot ));
$dots_x_row =floor( 1200 / $dot_size );

$edots ="<table class='edots'>\n";
$i =0;
foreach ($dots as $paper_id =>$p) {
	if ($p['pc'] == 'Y') {
		if (!$i) $edots .="<tr>\n";
	
		$status =$p['status'];
		$class =($p['qaok'] ? 'qaok' : $status);
		$edots .="<td class='$class" .($status == 'a' ? ' blink' : false) ."' title='$paper_id'></td>\n";
		if ($i < $dots_x_row) $i ++;
		else {
			$edots .="</tr>\n";
			$i =0;
		}
	}
}
$edots .="</table>\n";


/*-----------------------------------------------------------------------------
  NUMBERS
*/

$p_available =round($stats['processed'] *100 /($ndot-$stats['nofiles']));
$p_qa =round($stats['qaok'] *100 /$stats['g']);
$p_files =round($stats['files'] *100 /$ndot);
$p_nofiles =round($stats['nofiles'] *100 /$ndot);
$p_processed =100 -$p_files -$p_nofiles;


$percent =array(
	'g' =>($p_qa ? "$p_qa<small>%</small>" : false),
	'r' =>"($p_available<small>% of available</small>)",
	'a' =>'',
	'files' =>$p_files .'<small>%</small>',
	'y' =>$p_processed .'<small>%</small>',
	'nofiles' =>$p_nofiles .'<small>%</small>'
	);

$stats_table ="<table class='stats'>\n";
foreach ($stats_title as $name =>$title) {
	$stats_table .="<tr><th>$title</th><th></th></tr>\n"
		."<tr><td class='$name'>$stats[$name]</td><td vertical-align='middle' class='percent'>$percent[$name]</td></tr>\n";
}
$stats_table .="</table>\n";

/*-----------------------------------------------------------------------------
  RATES
*/

$lp =false; // Last Processed
$phmax =0;
foreach ($stats_db as $tm2 =>$x) {
	list( $y, $m, $d, $h ) =explode( '-', $tm2 );
	
	if ($lp) {
		$ph =$x['processed'] -$lp;
		
		if ($ph) {
			if ($tm2 == $tm) {
				$ph =round( $ph *(60 /date('i')), 1 );
			}
			
			$phmax =max( $phmax, $ph );
			$rates["$y-$m-$d"][$h] =$ph;
		}
	}
	
	$lp =$x['processed'];
}

$i =0;
krsort( $rates );
$rates_html .="<table class='rates'>\n";
foreach ($rates as $day =>$x) {
	krsort( $x );

	if ($i < 9) {
		$rates_html .="<tr><th colspan='2'>$day</th></tr>\n";
		$i ++;
	}
	
	foreach ($x as $h =>$ph) {
		if ($i >= 10) break;
		$w =1000*$ph/$phmax;
		$style ="background-image: url(1px.png); background-repeat: no-repeat; background-size: ${w}px 100%;";
		
		$rates_html .="<tr><td>$h</td><td style='$style'>$ph p/h</td></tr>\n";
		$i ++;
	}
	
}
$rates_html .="</table>\n";

/*-----------------------------------------------------------------------------
  CHARTS
*/

foreach ($stats_db as $tm2 =>$x) {
	list( $y, $m, $d, $h ) =explode( '-', $tm2 );
	$m --;

	$green =$x['g'] -$x['qaok'];
	
	$chart1_data .="data.addRow([new Date($y,$m,$d,$h,59),$x[files],$x[a],$x[qaok],$green,$x[y],$x[r],$x[nofiles]]);\n";
}


/*-----------------------------------------------------------------------------
  PARSE TEMPLATE
*/

$tmpl =implode( '', file( APP_TEMPLATE_HTML ));

foreach (array( 'warning', 'edots', 'rates_html', 'stats_table', 'chart1_data', 'dot_size' ) as $var) {
	$tmpl =str_replace( '{'.$var.'}', $$var, $tmpl );
}

echo $tmpl;

?>