#!/usr/bin/php
<?php

// 2017.01.03 bY Stefano.Deiuri@Elettra.Eu

require( '../config.php' );
require_lib( 'cws','1.0' );

config( 'spms_stats_importer' );

echo "\n";

echo "Load PO file (" .APP_PO .")... ";
$po =file_read_json( APP_PO, true );
if ($po) echo_ok();
else {
	echo_error( "ERROR! (Unable to read file)" );
	return;
}

echo "\n";

if (!file_exists( APP_EDOT_XML ) || (time() -filemtime( APP_EDOT_XML )) > 60) {
	echo "Get EDOT XML file " .APP_EDOT_XML_URL ."... ";
	$xmlfile =file( APP_EDOT_XML_URL );
	$xml_str =implode( '', $xmlfile );
	file_write( APP_EDOT_XML, $xml_str, 'w' );
	if (count($xmlfile)) echo_ok();
	else echo_error( "ERROR! (No data)" );
	
} else {
	echo "Load EDOT XML file " .APP_EDOT_XML_URL ."... ";
	$xml_str =implode( '', file( APP_EDOT_XML ));
	echo_ok();
}

$xml =simplexml_load_string( $xml_str );

$stats =array( 'qaok' =>0, 'files' =>0, 'g' =>0, 'y' =>0, 'r' =>0, 'nofiles' =>0 );

$dots =array();
foreach ($xml->papers->paper as $paper) {
	$x =(array)$paper->attributes();
	$paper_id =(string)$paper['SESSION'] .(string)$paper['SEQUENCE'];

	$qaok =((string)$paper['QA'] == 'FQ');

	$paper_status =strtolower((string)$paper['CODE']);
	if ((string)$paper['QA'] == 'QAF') $paper_status ='a';
	else if (!$paper_status) $paper_status ='nofiles';

	$dots[$paper_id] =array( 'pc' =>$po[$paper_id]['primary_code'], 'status' =>$paper_status, 'qaok' =>$qaok );

	if (isset($stats[$paper_status])) $stats[$paper_status] ++;
	else $stats[$paper_status] =1;
			
	if ($qaok) $stats['qaok'] ++;
}

echo "Write EDOT file (" .APP_EDOT .")... ";
file_write_json( APP_EDOT, $dots );
echo_ok();

echo "\n";

$stats['processed'] =$stats['g'] +$stats['y'] +$stats['r'];

if (file_exists(APP_STATS)) {
	echo "Load STATS file (" .APP_STATS .")... ";
	$stats_db =file_read_json( APP_STATS, true );
	echo_ok();
} else {
	$stats_db =false;
}

echo "Update STATS file... ";
$tm =date( 'Y-m-d-H' );
$stats_db[$tm] =$stats;
echo_ok();

echo "Write STATS file (" .APP_STATS .")... ";
file_write_json( APP_STATS, $stats_db );
echo_ok();

echo "\n";

?>